import asyncio

from discord.utils import find

from jarvis import jarvis
from jarvis.db.types import Setting


@jarvis.event
async def on_guild_join(guild):
    general = find(lambda x: x.name == "general", guild.channels)
    if general and general.permissions_for(guild.me).send_messages:
        await general.send(
            "Allow me to introduce myself. I am J.A.R.V.I.S., a virtual "
            + "artificial intelligence, and I'm here to assist you with a "
            + "variety of tasks as best I can, "
            + "24 hours a day, seven days a week."
        )
        await asyncio.sleep(1)
        await general.send("Importing all preferences from home interface...")

        # Set some default settings
        setting = Setting(guild=guild.id, setting="massmention", value=5)
        setting.insert()

        await general.send("Systems are now fully operational")
